****     Sigma Intro     ****
****    March 1989 by   ****
****   Joakim Hallberg   ****
**** Mastermind of Sigma ****

custom:     equ   $dff000
bplcon0:    equ   $100
bplcon1:    equ   $102
bplcon2:    equ   $104
bpl1mod:    equ   $108
ddfstrt:    equ   $092
ddfstop:    equ   $094
diwstrt:    equ   $08e
diwstop:    equ   $090
vposr:      equ   $004
color00:    equ   $180
color01:    equ   $182
color17:    equ   $1a2
color18:    equ   $1a4
color19:    equ   $1a6
color20:    equ   $1a8
color21:    equ   $1aa
color22:    equ   $1ac
color23:    equ   $1ae
color24:    equ   $1b0
color25:    equ   $1b2
color26:    equ   $1b4
color27:    equ   $1b6
dmacon:     equ   $096
cop1lc:     equ   $080
copjmp1:    equ   $088

      lea      custom,a0
      move.w   #$1200,bplcon0(a0)
      move.w   #$0000,bpl1mod(a0)
      move.w   #$0000,bplcon1(a0)
      move.w   #$0024,bplcon2(a0)
      move.w   #$0038,ddfstrt(a0)
      move.w   #$00d0,ddfstop(a0)
      move.w   #$2c81,diwstrt(a0)
      move.w   #$f4c1,diwstop(a0)
      
      move.w   #$0000,color00(a0)
      move.w   #$00f0,color01(a0)
      move.w   #$000f,color17(a0)
      move.w   #$000b,color18(a0)
      move.w   #$0007,color19(a0)
      move.w   #$0000,color20(a0)
      move.w   #$000f,color21(a0)
      move.w   #$000b,color22(a0)
      move.w   #$0007,color23(a0)
      move.w   #$0000,color24(a0)
      move.w   #$000f,color25(a0)
      move.w   #$000b,color26(a0)
      move.w   #$0007,color27(a0)

      move.l   #$20000,a1
      lea      copperl,a2
cloop:
      move.l   (a2),(a1)+
      cmp.l    #$fffffffe,(a2)+
      bne      cloop

      move.l   #$25000,a1
      lea      sprite0,a2
sprloop0:
      move.l   (a2),(a1)+
      cmp.l    #$00000000,(a2)+
      bne      sprloop0

      move.l   #$26000,a1
      lea      sprite1,a2
sprloop1:
      move.l   (a2),(a1)+
      cmp.l    #$00000000,(a2)+
      bne      sprloop1

      move.l   #$27000,a1
      lea      sprite2,a2
sprloop2:
      move.l   (a2),(a1)+
      cmp.l    #$00000000,(a2)+
      bne      sprloop2

      move.l   #$28000,a1
      lea      sprite3,a2
sprloop3:
      move.l   (a2),(a1)+
      cmp.l    #$00000000,(a2)+
      bne      sprloop3

      move.l   #$29000,a1
      lea      sprite4,a2
sprloop4:
      move.l   (a2),(a1)+
      cmp.l    #$00000000,(a2)+
      bne      sprloop4
      

      move.l   #$00000000,$30000

      move.l   #$20000,custom+cop1lc
      move.l   #$21000,a1
      move.w   #$2000,d0
floop:
      move.l   #$fffffffe,(a1)+
      subq.w   #1,d0
      bne      floop

      lea      custom,a0
      move.l   #$20000,d0
      move.w   #$0080,dmacon(a0)
      move.w   d0,copjmp1(a0)
      move.w   #$83a0,dmacon(a0)

compare:
      bra      compare
      move.b   $dff006,d2
      cmp.b    #$ff,d2
      bne      compare
      jsr      vloop2(pc)      
      jsr      vloop4(pc)
      cmp.b    #64,d0
      bne      compare

compare2:
      move.b   $dff006,d2
      cmp.b    #$ff,d2
      bne      compare2
      jsr      vloop(pc)
      jsr      vloop4(pc)
      cmp.b    #64,d1
      bne      compare2
      
            
compare3:
      move.b   $dff006,d2
      cmp.b    #$ff,d2
      bne      compare3     
      jsr      vloop(pc)
      jsr      vloop3(pc)
      cmp.b    #250,d0
      bne      compare3

compare4:
      move.b   $dff006,d2
      cmp.b    #$ff,d2
      bne      compare4
      jsr      vloop(pc)
      jsr      vloop3(pc)
      cmp.b    #250,d1
      bne      compare4
      bra      compare


copperl:
      dc.w     $00e0,$0002
      dc.w     $00e2,$1000
      dc.w     $0120,$0002
      dc.w     $0122,$5000
      dc.w     $0124,$0002
      dc.w     $0126,$6000
      dc.w     $0128,$0002
      dc.w     $012a,$7000
      dc.w     $012c,$0002
      dc.w     $012e,$8000
      dc.w     $0130,$0002
      dc.w     $0132,$9000
      dc.w     $0134,$0003
      dc.w     $0136,$0000
      dc.w     $0138,$0003
      dc.w     $013a,$0000
      dc.w     $013c,$0003
      dc.w     $013e,$0000
      dc.w     $c001,$fffe
      dc.w     $182,$101
      dc.w     $180,$101
      dc.w     $c201,$fffe
      dc.w     $182,$202
      dc.w     $180,$202
      dc.w     $c401,$fffe
      dc.w     $182,$303
      dc.w     $180,$303
      dc.w     $c601,$fffe
      dc.w     $182,$404
      dc.w     $180,$404
      dc.w     $c801,$fffe
      dc.w     $182,$505
      dc.w     $180,$505
      dc.w     $ca01,$fffe
      dc.w     $182,$606
      dc.w     $180,$606
      dc.w     $cc01,$fffe
      dc.w     $182,$505
      dc.w     $180,$505
      dc.w     $ce01,$fffe
      dc.w     $182,$404
      dc.w     $180,$404
      dc.w     $d001,$fffe
      dc.w     $182,$303
      dc.w     $180,$303
      dc.w     $d201,$fffe
      dc.w     $182,$202
      dc.w     $180,$202
      dc.w     $d401,$fffe
      dc.w     $182,$101
      dc.w     $180,$101
      dc.w     $d601,$fffe
      dc.w     $182,$000
      dc.w     $180,$000
      dc.w     $ffff,$fffe


vloop:
      move.b   $25001,d0
      add.b    #1,d0
      move.b   d0,$29001
      rts

vloop2:
      move.b   $25001,d0
      subq.b   #1,d0
      move.b   d0,$29001
      rts

vloop3:
      move.b   $26001,d1
      add.b    #1,d1
      move.b   d1,$26001
      rts

vloop4:
      move.b   $26001,d1
      subq.b   #1,d1
      move.b   d1,$26001
      rts

vloop5:
      move.b   $27001,d2
      add.b    #1,d2
      move.b   d1,$27001
      rts

vloop6:
      move.b   $27001,d2
      subq.b   #1,d2
      move.b   d2,$27001
      rts

vloop7:  
      move.b   $28001,d3
      add.b    #1,d3
      move.b   d3,$28001
      rts

vloop8:
      move.b   $28001,d3 
      subq.b   #1,d3
      move.b   d3,$28001
      rts

vloop9:
      move.b   $29001,d4
      add.b    #1,d4
      move.b   d4,$29001
      rts

vloop10:
      move.b   $29001,d4
      subq.b   #1,d4
      move.b   d4,$29001
      rts

tloop:
      move.w   #3000,d5
ause:
      dbf     d5,ause
      rts


sprite0:
      dc.w     $6d60,$8300
      dc.l     $01FF01FF,$020203FE,$05F4060C,$0BE80C18,$17D01830
      dc.l     $2FA03060,$5F4060C0,$BE80C180,$5F4060C0,$2FA03060,$17D01830
      dc.l     $0BE80C18,$05F4060C,$02FA0306,$017D0183,$02FA0306,$05F4060C
      dc.l     $0BE80C18,$17D01830,$2FA03060,$40407FC0,$FF80FF80,$00000000
      
sprite1:
      dc.w     $6d74,$8300
      dc.l     $01FF01FF,$020203FE,$05F4060C,$0BE80C18,$17D01830 
      dc.l     $2FA03060,$5F4060C0,$BE80C180,$5F4060C0,$2FA03060,$17D01830 
      dc.l     $0BE80C18,$05F4060C,$02FA0306,$017D0183,$02FA0306,$05F4060C 
      dc.l     $0BE80C18,$17D01830,$2FA03060,$40407FC0,$FF80FF80,$00000000 

sprite2:
      dc.w     $6d88,$8300
      dc.l     $01FF01FF,$020203FE,$05F4060C,$0BE80C18,$17D01830 
      dc.l     $2FA03060,$5F4060C0,$BE80C180,$5F4060C0,$2FA03060,$17D01830 
      dc.l     $0BE80C18,$05F4060C,$02FA0306,$017D0183,$02FA0306,$05F4060C 
      dc.l     $0BE80C18,$17D01830,$2FA03060,$40407FC0,$FF80FF80,$00000000 

sprite3:
      dc.w     $6d9c,$8300
      dc.l     $01FF01FF,$020203FE,$05F4060C,$0BE80C18,$17D01830 
      dc.l     $2FA03060,$5F4060C0,$BE80C180,$5F4060C0,$2FA03060,$17D01830 
      dc.l     $0BE80C18,$05F4060C,$02FA0306,$017D0183,$02FA0306,$05F4060C 
      dc.l     $0BE80C18,$17D01830,$2FA03060,$40407FC0,$FF80FF80,$00000000 

sprite4:
      dc.w     $6db0,$8300
      dc.l     $01FF01FF,$020203FE,$05F4060C,$0BE80C18,$17D01830 
      dc.l     $2FA03060,$5F4060C0,$BE80C180,$5F4060C0,$2FA03060,$17D01830 
      dc.l     $0BE80C18,$05F4060C,$02FA0306,$017D0183,$02FA0306,$05F4060C 
      dc.l     $0BE80C18,$17D01830,$2FA03060,$40407FC0,$FF80FF80,$00000000 
   
