openlibrary=	-30-522
forbid=		-30-102
permit=		-30-108
allocmem=	-30-168
freemem=	-30-180
startlist=	38
execbase=	4
numplanes=	1
planewith=	40
planehigh=	224
planesize=	planewith*planehigh
allocsize=	planesize*numplanes
CLsize=		3000			;(numplns*8)+4
chip=		2
clear=		$10000

cbadr:	dc.l	0
cbc:	dc.l	0

start:
	move.l	$04,a6
	lea	gfxname,a1
	jsr	-408(a6)
	move.l	d0,gfxbase
	move.l	d0,a0
	move.l	50(a0),oldclist
	move.l	#newclist,50(a0)
	move.l	gfxbase,a6
	lea	bitmap,a0
	move.l	#$01,d0
	move.l	#336,d1
	move.l	#200,d2
	jsr	-390(a6)
	move.l	#$60000,plane1
	lea	rastport,a1
	jsr	-198(a6)
	move.l	#bitmap,r_bitmap
	lea	rastport,a1
	jsr	-48(a6)
	move.l	#scrollm,zeiger
	move.l	$6c,oldirq+2
	move.l	#newirq,$6c
wait:
	btst	#6,$bfe001
	bne.s	wait
	move.l	oldirq+2,$6c
	move.l	gfxbase,a0
	move.l	oldclist,50(a0)
	move.l	$04,a6
	move.l	gfxbase,a1
	jsr	-414(a6)
	rts

newirq:
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	gfxbase,a6
	lea	rastport,a1
	move.l	#$01,d0
	clr.l	d1
	clr.l	d2
	move.l	#000,d3
	move.l	#336,d4
	move.l	#200,d5
	jsr	-396(a6)
	sub.b	#$01,rows
	bne.s	exit
	move.b	#$08,rows
	lea	rastport,a1
	move.l	#320,d0
*	jsr     upndown
	jsr	-240(a6)
	lea	rastport,a1
	move.l	zeiger,a0
	move.l	#$01,d0
	jsr	-60(a6)
	addq.l	#$01,zeiger
	cmp.l	#end,zeiger
	blt.s	exit
	move.l	#scrollm,zeiger
exit:
	movem.l	(sp)+,d0-d7/a0-a6
oldirq:
	jmp	$00000000

newclist:
	dc.w	$008e,$2c81,$0090,$f4c1,$0092,$0038,$0094,$00d0
	dc.w	$0102,$0000,$0104,$0000,$0108,$0002,$010a,$0002
	dc.w	$0100,$1200,$0180,$0000,$0182,$0fff
	dc.w	$00e0,$0006,$00e2,$0000
	dc.w	$ffff,$fffe
scrollm:
	dc.b	"TEAM'89         "
end:
	even
zeiger:
	dc.l	0
oldclist:
	dc.l	0
gfxbase:
	dc.l	0
gfxname:
	dc.b	"graphics.library",0
	even
bitmap:
	blk.w	4,0
plane1:
	blk.l	20,0
rastport:
	dc.l	0
r_bitmap:
	blk.l	30,0
rows:
	dc.b	2
	even
sine:
	cmp.l	#$ff,d0
	ble.b	ntbig
	sub.l	#$100,d0
	jmp	sine
ntbig:	move.l	#0,d1
	cmp.l	#$80,d0
	ble.b	nneg
	move.l	#-1,d1
	sub.l	#$80,d0
nneg:	lea	sinetable,a0
	cmp.l	#64,d0
	ble.b	nomv
	move.l	#64,d2
	sub.l	d2,d0
	sub.l	d0,d2
	move.l	d2,d0
nomv:	add.l	d0,a0
	move.b	(a0),d0
	cmp.l	#-1,d1
*	bne	nneged
	move.l	#$80,d2
	sub.l	d2,d0
	sub.l	d0,d2
	move.l	d2,d0
sinetable:
	dc.b	128,131,134,137,140,144,147,150,153
	dc.b	156,159,162,165,168,171,174,177,179
	dc.b	182,185,188,191,193,196,199,201,204
	dc.b	206,209,211,213,216,218,220,222,224
	dc.b	226,228,230,232,234,235,237,239,240
	dc.b	241,243,244,245,246,248,249,250,250
	dc.b	251,252,253,253,254,254,254,255,255
        dc.b    254,254
cb:	dc.b	00,05,10,15,20,25,30,35,40,45
	dc.b	50,55,60,65,70,75,80,85,90,95
	dc.b	100,105,110,115,120,125,130,135,140,145
	dc.b	150,155,160,165,170,175,180,185,190,195
