	jmp 	start

intena=	$9a
dmacon=	$96
color00=	$180
cop1lc=	$80
cop2lc=	$84
copjmp1=	$88
copjmp2=	$8a
ciaapra=	$bfe001
openlibrary=	-30-522
forbid=	-30-102
permit=	-30-108
allocmem=	-30-168
freemem=	-30-180
startlist=	38
execbase=	4
chip=	2

cladr:	dc.l	0

grname:	dc.b	"graphics.library",0
	even

clstart:
	dc.w	color00,$0000
	dc.w	$640f,$fffe
	dc.w	color00,$0f00
	dc.w	$be0f,$fffe
	dc.w	color00,$0fb0
	dc.w	$ffff,$fffe
clend:

clsize=	clend - clstart

start:
	move.l	execbase,a6
	moveq	#clsize,d0
	moveq	#chip,d1
	jsr	allocmem(a6)
	move.l	d0,cladr
	beq.s	ende

	lea	clstart,a0
	move.l	cladr,a1
	moveq	#clsize-1,d0
	
clcopy:
	move.b	(a0)+,(a1)+
	dbf	d0,clcopy

	jsr	forbid(a6)
	lea	$dff000,a5
	move.w	#$03a0,dmacon(a5)
	move.l	cladr,cop1lc(a5)
	clr.w	copjmp1(a5)

	move.w	#$8280,dmacon(a5)

wait:
	btst	#6,ciaapra
	bne.s	wait

	move.l	#grname,a1
	clr.l	d0
	jsr	openlibrary(a6)
	move.l	d0,a4
	move.l	startlist(a4),cop1lc(a5)
	clr.w	copjmp1(a5)
	move.w	#$8310,dmacon(a5)
	jsr	permit(a6)

	move.l	cladr,a1
	moveq	#clsize,d0
	jsr	freemem(a6)

ende:
	clr.l	d0
	rts



