custom:     equ         $dff000
bplcon0:    equ         $100
bplcon1:    equ         $102
bplcon2:    equ         $104
bpl1mod:    equ         $108
ddfstrt:    equ         $092
ddfstop:    equ         $094
diwstrt:    equ         $08e
diwstop:    equ         $090
vposr:      equ         $004
color00:    equ         $180
color01:    equ         $182
color17:    equ         $1a2
color18:    equ         $1a4
color19:    equ         $1a6
dmacon:     equ         $096
cop1lc:     equ         $080
copjmp1:    equ         $08
joy1dat:    equ         $dff00c
pat:        equ         $bfe001

            lea         custom,a0
            move.w      #$1200,bplcon0(a0)
            move.w      #$0000,bpl1mod(a0)
            move.w      #$0000,bplcon1(a0)
            move.w      #$0024,bplcon2(a0)
            move.w      #$0025,ddfstrt(a0)
            move.w      #$00d0,ddfstop(a0)
            move.w      #$1f18,diwstrt(a0)
            move.w      #$00d8,diwstop(a0)

            move.w      #$0008,color00(a0)
            move.w      #$0000,color01(a0)
            move.w      #$0fff,color17(a0)
            move.w      #$0fff,color18(a0)
            move.w      #$0fff,color19(a0)
 
            move.l      #$20000,a1
            lea         copperl,a2
cloop:
            move.l      (a2),(a1)+
            cmp.l       #$fffffffe,(a2)+
            bne         cloop

            move.l      #$25000,a1
            lea         sprite,a2
sprloop:
            move.l      (a2),(a1)+
            cmp.l       #$00000000,(a2)+
            bne         sprloop
 
            move.l      #$00000000,$30000

            move.l      #$21000,a1
            move.w      #2000,d0
floop:
            move.l      #$ffffffff,(a1)+
            subq.w      #1,d0
            bne         floop
 
            move.w      #$0080,custom+dmacon
            move.l      #$20000,custom+cop1lc
            move.w      custom+copjmp1,d0
            move.w      #$83a0,custom+dmacon

hopp:       jsr         readjoy1

            cmp.b       #4,d0
            beq.s       mainh
            cmp.b       #8,d0
            beq.s       mainv
            jmp         hopp
mainh:                       
            jsr         compare1(pc)
            jsr         loop1
            bra         hopp
mainv:                       
            jsr         compare1(pc)
            jsr         loop2
            bra         hopp

loop1:
            lea         $25001,a0
            jsr         aloop(pc) 
            rts
loop2:
            lea         $25001,a0
            jsr         sloop(pc) 
            rts   
    
aloop: 
            move.b      (a0),d0
            add.b       #1,d0
            move.b      d0,(a0)
            rts
sloop:
            move.b      (a0),d0
            subq.b      #1,d0
            move.b      d0,(a0)
            rts

compare1:
            move.b      $dff006,d0
            cmp.b       #$d0,d0
            bne         compare1
            rts

readjoy1:   movem.l     d1-d3/a0,-(a7)
            lea         joy1dat,a0
            moveq       #7,d2
            moveq       #0,d0
            move.b      pat,d1
            btst        d2,d1
            bne.s       roj1
            bset        #4,d0
roj1:       move.w      (a0),d1
            btst        d2,d1
            beq.s       roj2
            bset        #3,d0
roj2:       btst        #1,d1
            beq.s       roj3
            bset        #3,d0
roj3:       move.b      d1,d3
            and.b       #%10,d1
            lsr.b       #1,d1
            or.b        d1,d0
            and.b       #%1,d3
            eor.b       d3,d0
            move.w      (a0),d1
            lsr.w       #8,d1
            move.b      d1,d3
            and.b       #%10,d1
            or.b        d1,d0
            and.b       #%1,d3
            lsl.b       #1,d3
            eor.b       d3,d0
            movem.l     (a7)+,d1-d3/a0
            rts

copperl:
            dc.w        $00e0,$0002
            dc.w        $00e2,$1000
            dc.w        $0120,$0002
            dc.w        $0122,$5000
            dc.w        $0124,$0003
            dc.w        $0126,$0000
            dc.w        $0128,$0003
            dc.w        $012a,$0000
            dc.w        $012c,$0003
            dc.w        $012e,$0000
            dc.w        $0130,$0003
            dc.w        $0132,$0000
            dc.w        $0134,$0003
            dc.w        $0136,$0000
            dc.w        $0138,$0003
            dc.w        $013a,$0000
            dc.w        $013c,$0003
            dc.w        $013e,$0000
            dc.w        $ffff,$fffe
sprite:
            dc.w        $2d60,$2e00
            dc.w        $0001,$0000
            dc.w        $0000,$0000
