OPENLIB:   EQU -408
ALLOCMEM:  EQU -198
FREEMEM:   EQU -210
MEMF_CHIP: EQU $10002

BEGIN:	   MOVEM.L D0-D7/A0-A6,-(SP)
	MOVE.L	$4.W,A6
	MOVE.L	#COPSIZE+PICSIZE,D0
	MOVE.L	#MEMF_CHIP,D1
	JSR ALLOCMEM(A6)
	MOVE.L	D0,NEWCOPPER
	BEQ.L	ALLOCERROR
	ADD.L	#COPSIZE,D0
	MOVE.L	D0,BPPTR

INITBP:	   MOVE.L  D0,D7
	SWAP	D7
	MOVE.W	D7,BP1H
	SWAP	D7
	MOVE.W	D7,BP1L

	ADD.L	#BPSIZE,D7
	SWAP	D7
	MOVE.W	D7,BP2H
	SWAP	D7
	MOVE.W	D7,BP2L

	ADD.L	#BPSIZE,D7
	SWAP	D7
	MOVE.W	D7,BP3H
	SWAP	D7
	MOVE.W	D7,BP3L

	ADD.L	#BPSIZE,D7
	SWAP	D7
	MOVE.W	D7,BP4H
	SWAP	D7
	MOVE.W	D7,BP4L

	ADD.L	#BPSIZE,D7
	SWAP	D7
	MOVE.W	D7,BP5H
	SWAP	D7
	MOVE.W	D7,BP5L

	LEA.L	PIC+[5*BPSIZE],A0
	LEA.L	COLORS+2(PC),A1
	MOVEQ	#31,D7
INITCOLORS: MOVE.W  (A0)+,(A1)
	ADDQ.L	#4,A1
	DBF D7,INITCOLORS


	MOVE.W	#COPSIZE+PICSIZE-1,D7
MOVETOCHIP: MOVE.B  (A1)+,(A0)+
	DBF D7,MOVETOCHIP

	LEA.L	GFXNAME(PC),A1
	JSR OPENLIB(A6)
	TST.L	D0
	BEQ.S	GFXERROR
	MOVE.L	D0,A0
	MOVE.L	$26(A0),OLDCOPPER
	MOVE.W	#$4000,$DFF09A
DISABLE:    TST.B   $DFF006
	BNE.S	DISABLE
	MOVE.W	$DFF002,DMABITS
	BSET	#7,DMABITS
	MOVE.W	#$7FFF,$DFF096
	MOVE.W	#$8380,$DFF096

	MOVE.L	NEWCOPPER(PC),$DFF080

MAIN:	    BTST    #6,$BFE001
	BNE.S	MAIN



EXIT:MOVE.L  OLDCOPPER(PC),$DFF080
	MOVE.W	DMABITS(PC),$DFF096
	MOVE.W	#$C000,$DFF09A
GFXERROR:   MOVE.L  NEWCOPPER(PC),A1
	MOVE.L	#COPSIZE+PICSIZE,D0
	JSR FREEMEM(A6)
ALLOCERROR: MOVEM.L (SP)+,D0-D7/A0-A6
	RTS

OLDCOPPER:  DC.L    0
NEWCOPPER:  DC.L    0
BPPTR:	    DC.L    0
DMABITS:    DC.W    0
GFXNAME:    DC.B    'GRAPHICS.LIBRARY',0
EVEN

COPPERLIST: DC.W    $008E,$2C81
	DC.W	$0090,$F4C1
	DC.W	$0092,$003B
	DC.W	$0094,$00D0
	DC.W	$0100,$5000
	DC.W	$0102,$0000
	DC.W	$0104,$0000
	DC.W	$0108,$0000
	DC.W	$010A,$0000

	DC.W	$00E0
BP1H:	    DC.W    $0000
	DC.W	$00E2
BP1L:	    DC.W    $0000

	DC.W	$00E4
BP2H:	    DC.W    $0000
	DC.W	$00E6
BP2L:	    DC.W    $0000

	DC.W	$00E8
BP3H:	    DC.W    $0000
	DC.W	$00EA
BP3L:	    DC.W    $0000

	DC.W	$00EC
BP4H:	    DC.W    $0000
	DC.W	$00EE
BP4L:       DC.W    $0000

	DC.W	$00F0
BP5H:	    DC.W    $0000
	DC.W	$00F2
BP5L:       DC.W    $0000

COLORS:	    DC.W    $0180,$0000
	DC.W	$0182,$0000
	DC.W	$0184,$0000
	DC.W	$0186,$0000
	DC.W	$0188,$0000
	DC.W	$018A,$0000
	DC.W	$018C,$0000
	DC.W	$018E,$0000
	DC.W	$0190,$0000
	DC.W	$0192,$0000
	DC.W	$0194,$0000
	DC.W	$0196,$0000
	DC.W	$0198,$0000
	DC.W	$019A,$0000
	DC.W	$019C,$0000
	DC.W	$019E,$0000
	DC.W	$01A0,$0000
	DC.W	$01A2,$0000
	DC.W	$01A4,$0000
	DC.W	$01A6,$0000
	DC.W	$01A8,$0000
	DC.W	$01AA,$0000
	DC.W	$01AC,$0000
	DC.W	$01AE,$0000
	DC.W	$01B0,$0000
	DC.W	$01B2,$0000
	DC.W	$01B4,$0000
	DC.W	$01B6,$0000
	DC.W	$01B8,$0000
	DC.W	$01BA,$0000
	DC.W	$01BC,$0000
	DC.W	$01BE,$0000

	DC.W   $FFFF,$FFFE
COPEND:
COPSIZE:    EQU COPEND-COPPERLIST
BPSIZE:	    EQU 320/8*200
PICSIZE:    EQU 5*BPSIZE+64

PIC:	    BLK.B   PICSIZE,0





