
; RI   Font  $60000

org	$6a000
load	$6a000

begin:
move.l	$4,a6
jsr	-132(a6)

move.b	#$ff,$bfd100
move.b	#$87,$bfd100

lea	gfxname,a1
jsr	-408(a6)
move.l	d0,gfxbase

lea	$70000,a0
lea	$80000,a1

clloop:
clr.l	(a0)+
cmp.l	a0,a1
bne	clloop

;lea	$65000,a0
;lea	$70000,a1
;bsr	unpack
bsr	setupcol

lea	font,a0
lea	$77000,a1
bsr	unpack

bsr	setcop

move.l	$6c,oldirq+2

move.l	gfxbase,a0
move.l	38(a0),oldclist

move.w	#$8180,$dff096
move.l	#newclist,$dff080
move.w	#0,$dff088

move.l	#newirq,$6c

wait:
btst	#6,$bfe001
bne	wait
eor.b #02,$bfe001
move.l	oldirq+2,$6c
move.l	oldclist,$dff080
move.w	#0,$dff088

move.w	#$f,$dff096
move.w	#0,$dff0a8
move.w	#0,$dff0b8
move.w	#0,$dff0c8
move.w	#0,$dff0d8

move.l	$4,a6
move.l	gfxbase,a1
jsr	-414(a6)
jsr	-138(a6)
rts

nextchr:
move.w	#26,newchar
move.l	textzeiger,a6

nextchr1:
move.b	(a6)+,d0
bne	nextchr2
move.l	#text,a6
bra	nextchr1

nextchr2:
cmp.b	#'+',d0
bne	nextchr3
move.b	(a6)+,d0
sub.b	#'0',d0
move.b	d0,xshft+1
bra	nextchr1

nextchr3:
move.l	#38,d1
lea	asc,a0

lprint:
cmp.b	(a0,d1.l),d0
beq	okprint
sub.l	#1,d1
bpl	lprint
add.l	#1,a6
move.l	a6,textzeiger
rts

okprint:
lsl.l	#2,d1
add.l	#atable,d1
move.l	d1,a2
move.l	(a2),a0
lea	$7b028,a1

move.l	a6,textzeiger
return:
move.l	#32,d0

loopset:
move.b	(a0),(a1)
move.b	1(a0),1(a1)
move.b	2(a0),2(a1)
clr.b	3(a1)
move.b	$28(a0),$2c(a1)
move.b	$29(a0),$2d(a1)
move.b	$2a(a0),$2e(a1)
clr.b	$2f(a1)
move.b	$50(a0),$58(a1)
move.b	$51(a0),$59(a1)
move.b	$52(a0),$5a(a1)
clr.b	$5b(a1)
add.l	#$78,a0
add.l	#$84,a1
sub.w	#1,d0
bne	loopset
rts

a = $77000
b = $77000 + [$28*3*32]
c = $77000 + [$28*3*64]
d = $77000 + [$28*3*96]

asc:	dc.b	"abcdefghijklmnopqrstuvwxyz0123456789!- "

even
atable:	dc.l	a,a+3,a+6,a+9,a+12,a+15,a+18,a+21,a+24,a+27
	dc.l	a+30,a+33,a+36
	dc.l	b,b+3,b+6,b+9,b+12,b+15,b+18,b+21,b+24,b+27
	dc.l	b+30,b+33,b+36
	dc.l	c,c+3,c+6,c+9,c+12,c+15,c+18,c+21,c+24,c+27
	dc.l	c+30,c+33,c+36

textzeiger:	dc.l	text

font:           blk.b   7194,0

clear1:
btst	#6,$dff002
bne	clear1
rts

newirq:
movem.l	d0-d7/a0-a6,-(a7)


move.l	#$7b000,d0
bsr	scroll
tst.w	newchar
bpl	irq1
eor.b #02,$bfe001
bsr	nextchr
eor.b #02,$bfe001
irq1:

endirq:
movem.l	(sp)+,d0-d7/a0-a6
oldirq:
jmp	$000000

unpack:	add.l	#12,a0
	move.l	4(a0),d0
	add.l	d0,a0
	add.l	#8,a0
	move.l	a0,cmapchunk

iff1:	cmp.l	#$424f4459,(a0)
	beq	iff0
	add.l	#2,a0
	bra	iff1

iff0:	move.l	4(a0),d0	; Anzahl Bytes
	add.l	#1,d0
	and.l	#$fffffffe,d0

	add.l	#8,a0		; Pointer to first Byte

iff4:	clr.l	d2
	move.b	(a0)+,d2
	bmi	iff6

iff5:	move.b	(a0)+,(a1)+
	subi.l	#1,d0
	subi.b	#1,d2
	bpl	iff5
	bra	iff7
	
iff6:	neg.b	d2
	beq	iff7

iff61:	move.b	(a0),(a1)+
	subi.b	#1,d2
	bpl	iff61
	subi.l	#1,d0
	add.l	#1,a0

iff7:	subi.l	#1,d0
	bmi	iff8
	beq	iff8
	bra	iff4

iff8:	move.l	cmapchunk,a0
	move.l	cmap,a1
	add.l	#8,a0
	move.l	#16,d0

cmaploop:
	clr.l	d1
	move.b	(a0),d1
	lsl.w	#4,d1
	move.b	2(a0),d1
	lsr.b	#4,d1
	or.b	1(a0),d1
	move.w	d1,(a1)+
	add.l	#3,a0
	sub.w	#1,d0
	bne	cmaploop
	rts

cmapchunk:
	dc.l	0

cmap:	dc.l	color1

color1:	blk.w	16,0

setupcol:
lea	color1,a0
lea	copcol,a1
move.l	#$01800000,d0
move.l	#16,d1

suc1:
move.w	(a0)+,d0
move.l	d0,(a1)+
add.l	#$00020000,d0
sub.w	#1,d1
bne	suc1
bchg #1,$bfe001
rts

newchar:dc.w	24
xshft:	dc.w	1

scroll:	tst.w	xshft
	bne	scroll2
	rts

scroll2:move.w	xshft,d1
	sub.w	d1,newchar
	move.l	d0,$dff054
	add.l	#2,d0
	move.l	d0,$dff050
	move.w	#0,$dff064
	move.w	#0,$dff066
	move.l	#$ffffffff,$dff044
	move.w	#16,d1
	sub.w	xshft,d1
	lsl.w	#8,d1
	lsl.w	#4,d1
	or.w	#$09f0,d1
	move.w	d1,$dff040
	move.w	#0,$dff042
	move.w	#$1816,$dff058
	bra	clear1

newclist:
dc.w	$008e,$2e81,$0090,$0ac1,$0092,$0038,$0094,$00d0
dc.w	$0102,$0000,$0104,$001f,$0108,$0078,$010a,$0078
dc.w	$0100,$4200,$0180,$0000

adr:
dc.w	$00e0,$0007,$00e2,$00,$00e4,$0007,$00e6,$28
dc.w	$00e8,$0007,$00ea,$50,$00ec,$0007,$00ee,$78
dc.w	$120,0,$122,0,$124,0,$126,0,$128,0,$12a,0,$12c,0
dc.w	$12e,0,$130,0,$132,0,$134,0,$136,0,$138,0,$13a,0
dc.w	$13c,0,$13e,0
copcol:
blk.l	16,0
dc.w	$4011,$fffe,$180,$fff
dc.w    $4111,$fffe,$180,$000
dc.w    $5811,$fffe,$180,$fff
dc.w    $5911,$fffe,$180,$000
frcol:
blk.w	32,0
dc.w	$d811,$fffe,$180,0,$182,$aaa,$184,$400
dc.w	$186,$004,$188,$040,$18a,$080,$18c,$800,$18e,$008
dc.w	$0100,$0200,$e0,$7,$e2,$b000
dc.w	$e4,$7,$e6,$b02c,$e8,$7,$ea,$b058,$102,0
dc.w	$108,$5c,$10a,$5c
;dc.w	$d911,$fffe,$180,$fff
dc.w    $da11,$fffe,$180,0,$0100,$3200
dc.w    $e011,$fffe,$180,$b00
dc.w    $e111,$fffe,$180,$f00
dc.w    $e411,$fffe,$180,$b00
dc.w    $e511,$fffe,$180,$000
dc.w    $e811,$fffe,$180,$00b
dc.w    $e911,$fffe,$180,$00f
dc.w    $ec11,$fffe,$180,$00b
dc.w    $ed11,$fffe,$180,$000
dc.w    $f011,$fffe,$180,$0b0
dc.w    $f111,$fffe,$180,$0f0
dc.w    $f411,$fffe,$180,$0b0
dc.w    $f511,$fffe,$180,$000
end:

oldclist:
dc.l	0
gfxbase:
dc.l	0
gfxname:
dc.b	"graphics.library",0
even

yko:	dc.b	$54,0

setcol:
move.l	a1,a3
add.l	#4,a3
move.w	(a4),2(a3)
rts

setcop:
lea	table,a6
lea	frcol,a2
lea	frcol,a1
move.l	trck1,a4
move.l	#8,d3
nsc:
move.b	(a6)+,d5
add.b	yko,d5
move.b	d5,(a2)+
move.b	#$11,(a2)+
move.w	#$fffe,(a2)+
move.l	#$01020000,(a2)+
bsr	setcol
add.l	#8,a1
add.l	#2,a4
subi.l	#1,d3
bne	nsc
rts

copscroll:
clr.l	d6
move.b	1(a2),d0
add.b	d0,(a2)
bcc	scrl1
add.l	#2,a3
cmp.l	a3,a5
bne	scrl2
lea	track1,a3

scrl2:
move.l	a3,a4
move.l	#7,d2
move.l	a1,a0
add.l	#4,a0

scrl3:
move.w	50(a0),58(a0)
sub.l	#8,a0
sub.l	#1,d2
bne	scrl3
move.l	a3,zwsp
jsr	setcol
move.l	zwsp,a3

scrl1:
clr.l	d0
move.b	(a2),d0
lsr.w	#2,d0
and.w	#$fff8,d0
lea	table,a0
add.l	d0,a0
move.l	#8,d2

scrl4:
move.b	(a0)+,d0
add.b	yko,d0
move.b	d0,(a1)
add.l	#8,a1
sub.l	#1,d2
bne	scrl4
rts

zwsp:	dc.l	0
count1:	dc.b	0,80
trck1:	dc.l	track1
etrck1:	dc.l	etrack1

table:	dc.b 13,21,29,37,45,53,61,69
	dc.b 14,22,30,38,46,54,62,70
	dc.b 15,23,31,39,47,55,63,71
	dc.b 16,24,32,40,48,56,64,72
	dc.b 17,25,33,41,49,57,65,73
	dc.b 18,26,34,42,50,58,66,74
	dc.b 19,27,35,43,51,59,67,75
	dc.b 20,28,36,44,52,60,68,76

track1:	dc.w    0,0,0,0,0,0,0,0 
        dc.w    0,0,0,0,0,0,0,0
        dc.w	$f00,$e00,$d00,$c00,$b00,$a00,$900,$800
	dc.w	$710,$620,$530,$440,$350,$260,$170
	dc.w	$080,$090,$0a0,$0b0,$0c0,$0d0,$0e0,$0f0
	dc.w	$e0,$d0,$c0,$b0,$a0,$90,$80
	dc.w	$71,$62,$53,$44,$35,$26,$17
	dc.w	$008,$009,$00a,$00b,$00c,$00d,$00e,$00f
	dc.w	$00e,$00d,$00c,$00b,$00a,$009,$008
	dc.w	$117,$226,$335,$444,$555,$666,$777
	dc.w	$888,$999,$aaa,$bbb,$ccc,$ddd,$eee,$ddd
	dc.w	$ccc,$bbb,$aaa,$999,$888,$887
	dc.w	$886,$885,$884,$883,$882,$881
	dc.w	$880,$990,$aa0,$bb0,$cc0,$dd0,$ee0,$ff0
	dc.w	$fe0,$fd0,$fc0,$fb1,$fa2,$f93,$f84,$f75
	dc.w	$f66,$f55,$f44,$f33,$f22,$f11
etrack1:

text:   dc.b    "+3yo! check this out! this is the ultimate team called+9    -"
        dc.b    "sigma-+1   +3with their first intro on this wonderful machine"
        dc.b    "  here is some info about our group  our group was founded by"
        dc.b    " megastar! that is me and mastermind! my pal  right now we "
        dc.b    "are three members  - megastar - mastermind - mr f -  the end "
        dc.b    "+9      +5bye!    +910  9  8  7  6  5  4  3  2  1  0       ",0
